ALTER PROCEDURE "dba"."pr_korrigeeri_koik"( in a_par char(40),in a_id1 integer, in a_s1 char(20) )
BEGIN
  declare ll_pos integer;
  set ll_pos=Locate(a_par,'_NULL');
  if ll_pos>1 then
    set a_id1=null;
    set a_s1=null;
    set a_par=Left(a_par,ll_pos-1);
  end if;
  case a_par
    when 'KandedKorrastadaDeebet' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."deeb"=a_s1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKreedit' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."kree"=a_s1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaMeetmed' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."meetnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKuluobjektid' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."kulnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTegevusalad' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."talnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKululiigid' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."artnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTululiigid' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."tulnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaProjektid' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."objectnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaOsakonnad' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."osaknr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaSubjektid' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."subjectnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTegevussuunad' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."suundnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTaotlused' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."taotnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaAllikad' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."alliknr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaRahavood' then
      update "pr_kanne" left outer join "gl_selectall" on "pr_kanne"."id"="gl_selectall"."id1" and "pr_kanne"."aasta"="gl_selectall"."id2"
        set "pr_kanne"."ravonr"=a_id1 where "gl_selectall"."id1" is not null
  end case;
END